package com.perforce.p4simulink.ui;

/**
 * Copyright (C) 2014 Perforce Software. All rights reserved.
 *
 * Please see LICENSE.txt in top-level folder of this distribution.
 */

import java.util.ArrayList;
import java.util.List;

import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.perforce.p4simulink.connection.Config;

public class P4ConnectionPane extends P4Pane {

	private JTextArea results;
	private JTextField username;
	private JTextField server;
	private JTextField workspace;

	public P4ConnectionPane(Config config) {
		if (config == null) {
			config = new Config();
		}
		username = new JTextField(config.getUser() != null ? config.getUser()
				: "P4USER");
		server = new JTextField(config.getPort() != null ? config.getPort()
				: "P4PORT");
		workspace = new JTextField(
				config.getClient() != null ? config.getClient() : "P4CLIENT");
		results = new JTextArea("");
	}

	public Object[] getFields() {

		checkNonEmpty(username);
		checkNonEmpty(server);
		checkNonEmpty(workspace);

		List<Object> fields = new ArrayList<>();
		fields.add("Server: ");
		fields.add(server);
		fields.add("User: ");
		fields.add(username);
		fields.add("Workspace: ");
		fields.add(workspace);

		if (results.getText() != null && !results.getText().isEmpty()) {
			fields.add("Results: ");
			fields.add(results);
		}

		return fields.toArray();
	}

	public String getUsername() {
		return username.getText();
	}

	public String getServer() {
		return server.getText();
	}

	public String getWorkspace() {
		return workspace.getText();
	}

	public void setResults(String message) {
		results.setText(message);
	}

	public String toString() {
		return "USERNAME: " + getUsername() + " HOST: " + getServer()
				+ " CLIENT_ID: " + getWorkspace();
	}
}
